Public Member Functions | Data Fields | Static Public Attributes

# MessageHistoryWindow Struct Reference

Inheritance diagram for MessageHistoryWindow:

## Public Member Functions
| MessageHistoryWindow (const WindowDesc *desc)
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | OnPaint ()
| The window must be repainted.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | OnInvalidateData (int data=0, bool gui_scope=true)
| Some data on this window has become invalid.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnResize ()
| Called after the window got resized.
## Data Fields
int | line_height
int | date_width
| < Height of a single line in the news histoy window including spacing.
Scrollbar * | vscroll
| < Width needed for the date part.
## Static Public Attributes
static const int | top_spacing = WD_FRAMERECT_TOP + 4
| Additional spacing at the top of the WID_MH_BACKGROUND widget.
static const int | bottom_spacing = WD_FRAMERECT_BOTTOM
| Additional spacing at the bottom of the WID_MH_BACKGROUND widget.

## Detailed Description

Definition at line 955 of file news_gui.cpp.

## Member Function Documentation

virtual void MessageHistoryWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 994 of file news_gui.cpp.

References _current_text_dir, _total_news, NewsItem::date, date_width, DrawNewsString(), DrawString(), Scrollbar::GetCapacity(), Scrollbar::GetPosition(), NewsItem::prev, SetDParam(), top_spacing, vscroll, WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, and WID_MH_BACKGROUND.

virtual void MessageHistoryWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 1035 of file news_gui.cpp.

References Scrollbar::GetScrolledRowFromWidget(), NewsItem::prev, ShowNewsMessage(), vscroll, WD_FRAMERECT_TOP, and WID_MH_BACKGROUND.

virtual void MessageHistoryWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true` |
| ) |  |  | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | Information about the changed data.
  | gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 1029 of file news_gui.cpp.

References _total_news, Scrollbar::SetCount(), and vscroll.

Referenced by OnPaint().

virtual void MessageHistoryWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 988 of file news_gui.cpp.

References Window::DrawWidgets(), and OnInvalidateData().

virtual void MessageHistoryWindow::OnResize | ( |  | ) | `[inline, virtual]`

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 1050 of file news_gui.cpp.

References Scrollbar::SetCapacity(), vscroll, and WID_MH_BACKGROUND.

virtual void MessageHistoryWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 972 of file news_gui.cpp.

References bottom_spacing, ConvertYMDToDate(), date_width, FONT_HEIGHT_NORMAL, GetStringBoundingBox(), max(), ORIGINAL_MAX_YEAR, SetDParam(), top_spacing, and WID_MH_BACKGROUND.

The documentation for this struct was generated from the following file:

- src/news_gui.cpp